#ifndef CUSTOMVIEW_H
#define CUSTOMVIEW_H

#include <QtGui>
#include <string>
#include "pictureitem.h"
#include <iostream>
#include <typeinfo>
#include <vector>
#include <sstream>
#include "orbital.h"
#include "configuration.h"
#include "helper.h"

using namespace std;

class CustomView : public QGraphicsView
{
    Q_OBJECT
public:
    explicit CustomView(QObject *parent = 0);
    ~CustomView();
    void putUpSpin(Side side, int pos);
    void putDownSpin(Side side, int pos);
    void putOrbital(Orbital orbital, int x0, int y1);
    void updateOrbitalStatus(int index, Side side, SpinType spin);

    vector<Orbital> leftOrbitals;
    vector<Orbital> rightOrbitals;

private:
    int doublyOccupiedOrbitals;
    PictureItem* selectedSpin;
    PictureItem* selectedOrbital;
protected:
    void mousePressEvent(QMouseEvent *event);
    void startImageAnimation(PictureItem *ball);
    void closeEvent(QCloseEvent *e);
    QObject *parent;
signals:
    void signalImageChosen(PictureItem *);
    void signalViewClosed();

    void setResult(QString result);
public slots:
    void initSpins(int nbr);
    void clearAndReplace();
    void collectData();
};


#endif // CUSTOMVIEW_H
