#ifndef MAINPAGE_H
#define MAINPAGE_H

#include <QWidget>
#include <QtGui>
#include "helper.h"
#include "orbital.h"
#include "spin.h"
#include "customview.h"

class MainPage : public QWidget
{
    Q_OBJECT
public:
    explicit MainPage(QWidget *parent = 0);
    ~MainPage();
    void drawOrbitals(QGraphicsScene &scene, Side side);
    void addImageOnScene(QGraphicsScene &scene, string path, int x, int y, int width = IMAGES_DIM, int height = IMAGES_DIM);
    void init();
private:
    QSplitter mainSplitter;
    QLayout *splitterLayout;
    QLayout *mainLayout;
    QPlainTextEdit formulaTextEdit;
    QGraphicsScene spinsGraphicsScene;
    CustomView spinsGraphicsView;

    QLabel labelDoublyOccupiedOrbitals;
    QSpinBox spinBoxDoublyOccupiedOrbitals;
    QPushButton reInitButton;
    QPushButton theoryButton;
    QPushButton helpButton;

signals:
    void theoryButtonPressed();
    void helpButtonPressed();
public slots:
    void clearFormula();
};

#endif // MAINPAGE_H
