#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    this->setGeometry(X0, Y0, WIDTH, HEIGHT);

    pagesWidget.addWidget(&mainPage);
    pagesWidget.addWidget(&helpPage);
    pagesWidget.addWidget(&theoryPage);

    pagesWidget.setCurrentIndex(MainPageIndex);

    connect(&helpPage, SIGNAL(backButtonPressed()), this, SLOT(displayMainPage()));
    connect(&theoryPage, SIGNAL(backButtonPressed()), this, SLOT(displayMainPage()));
    connect(&mainPage, SIGNAL(helpButtonPressed()), this, SLOT(displayHelpPage()));
    connect(&mainPage, SIGNAL(theoryButtonPressed()), this, SLOT(displayTheoryPage()));
    setCentralWidget(&pagesWidget);
}


void MainWindow::displayMainPage()
{
    pagesWidget.setCurrentIndex(MainPageIndex);
}

void MainWindow::displayHelpPage()
{
    pagesWidget.setCurrentIndex(HelpPageIndex);
}

void MainWindow::displayTheoryPage()
{
    pagesWidget.setCurrentIndex(TheoryPageIndex);
}


MainWindow::~MainWindow()
{
    delete ui;
}
