#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#define FORMULA_HEIGHT 100

//#include <QMainWindow>
#include <QtGui>
#include <iostream>
#include "pictureitem.h"
#include "sstream"
#include "helper.h"
#include "customview.h"
#include "helppage.h"
#include "theorypage.h"
#include "mainpage.h"

using namespace std;

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void initMainPage();

private:
    Ui::MainWindow *ui;


    QStackedWidget pagesWidget;
    HelpPage helpPage;
    TheoryPage theoryPage;
    MainPage mainPage;

public slots:
    void displayMainPage();
    void displayHelpPage();
    void displayTheoryPage();
};

#endif // MAINWINDOW_H
