#ifndef ORBITAL_H
#define ORBITAL_H
#include "helper.h"
#include <Qt/qpoint.h>

class Orbital
{
public:
    Orbital();

    Side getSide() const;
    void setSide(Side sd);

    Status getUpStatus() const;
    void setUpStatus(Status s);

    Status getDownStatus() const;
    void setDownStatus(Status s);

    int getX0() const;
    void setX0(int x0);

    int getY0() const;
    void setY0(int y0);

    int getIndex() const;
    void setIndex(int idx);

    float spinY();
    void setStatus(SpinType spin, Status stat);

private:
    Side side;
    Status upStatus;
    Status downStatus;

    //start coordinates for the orbital
    int x0;
    int y0;
    int index;

};

#endif // ORBITAL_H
