#include "pictureitem.h"
#include <sstream>

PictureItem::PictureItem(QSizeF size, const QPixmap& pixmap, QObject* parent) :
    QObject(parent), QGraphicsPixmapItem(pixmap)
{
    m_size = size;
    spin = Spin();
    orbital = Orbital();
}

PictureItem::~PictureItem()
{
}

QPropertyAnimation* PictureItem::animatePosition(const QPointF& start, const QPointF& end, int deltaT)
{
    QPropertyAnimation* anim = new QPropertyAnimation(this, "pos");

    anim->setDuration(deltaT);
    anim->setStartValue(start);
    anim->setEndValue(end);
    anim->setEasingCurve(QEasingCurve::Linear);
    return anim;
}


QRectF PictureItem::boundingRect() const
{
return QRectF(0, 0, m_size.width(), m_size.height());
}

PictureType PictureItem::getType() const
{
    return pictType;
}
void PictureItem::setType(PictureType tp)
{
    pictType = tp;
}
