#ifndef PICTUREITEM_H
#define PICTUREITEM_H
#include <QtGui>
#include <sstream>
#include "helper.h"
#include "spin.h"
#include "orbital.h"
#include <iostream>

using namespace std;


class PictureItem: public QObject, public QGraphicsPixmapItem
{
Q_OBJECT

    // Change picture position property for QPropertyAnimation
    Q_PROPERTY(QPointF pos READ pos WRITE setPos)

public:
    enum
    {
        PictureItemType = UserType + 1
    };

public:
    PictureItem(QSizeF size, const QPixmap& pixmap = 0, QObject* parent = 0);
    ~PictureItem();
    QRectF boundingRect() const;

    int type() const
    {
        return PictureItemType;
    }

    QPropertyAnimation* animatePosition(const QPointF& start, const QPointF& end, int deltaT);

public slots:


private:
    QSizeF m_size;
    PictureType pictType;

public:
    Spin spin;
    Orbital orbital;
    PictureType getType() const;
    void setType(PictureType tp);
};

#endif // PICTUREITEM_H
