#include "theorypage.h"

TheoryPage::TheoryPage(QWidget *parent) :
    QWidget(parent)
{
    layout = new QGridLayout();

    nbImages = 6;

    createImage(image1Label, "theory/theory_page1.png");
    imagesStackedWidget.addWidget(&image1Label);

    createImage(image2Label, "theory/theory_page2.png");
    imagesStackedWidget.addWidget(&image2Label);

    createImage(image3Label, "theory/theory_page3.png");
    imagesStackedWidget.addWidget(&image3Label);

    createImage(image4Label, "theory/theory_page4.png");
    imagesStackedWidget.addWidget(&image4Label);

    createImage(image5Label, "theory/theory_page5.png");
    imagesStackedWidget.addWidget(&image5Label);

    createImage(image6Label, "theory/theory_page6.png");
    imagesStackedWidget.addWidget(&image6Label);

    nextButton.setText(">");
    nextButton.setMaximumWidth(20);
    connect(&nextButton, SIGNAL(clicked()), this, SLOT(displayNextImage()));

    prevButton.setText("<");
    prevButton.setMaximumWidth(20);
    prevButton.setEnabled(false);
    connect(&prevButton, SIGNAL(clicked()), this, SLOT(displayPrevImage()));

    backButton.setText("Back");
    backButton.setMaximumWidth(120);
    connect(&backButton, SIGNAL(clicked()), this, SIGNAL(backButtonPressed()));

    ((QGridLayout *)layout)->addWidget(&imagesStackedWidget, 0, 0, 1, 3);
    ((QGridLayout *)layout)->addWidget(&prevButton, 1, 1, 1, 1);
    ((QGridLayout *)layout)->addWidget(&nextButton, 1, 2, 1, 1);
    ((QGridLayout *)layout)->addWidget(&backButton, 1, 0, 1, 1);
    this->setLayout(layout);
}

void TheoryPage::displayPrevImage()
{
    int currIdx = imagesStackedWidget.currentIndex();
    imagesStackedWidget.setCurrentIndex(currIdx - 1);

    if(imagesStackedWidget.currentIndex() == 0)//if it is the first image
        prevButton.setDisabled(true);
    if(imagesStackedWidget.currentIndex() == nbImages - 2)//it's the image before the last
        nextButton.setEnabled(true);
}

void TheoryPage::displayNextImage()
{
    int currIdx = imagesStackedWidget.currentIndex();
    imagesStackedWidget.setCurrentIndex(currIdx + 1);

    if(imagesStackedWidget.currentIndex() == 5)//if it is the first image
        nextButton.setDisabled(true);
    if(imagesStackedWidget.currentIndex() == 1)//it's the image before the last
        prevButton.setEnabled(true);
}


TheoryPage::~TheoryPage()
{
    delete layout;
}

void TheoryPage::createImage(QLabel &label, string imagePath)
{
    stringstream str;
    str << SC_PATH << imagePath;
    QPixmap pmap(str.str().c_str());
    pmap = pmap.scaled(QSize(WIDTH, HEIGHT - 60), Qt::KeepAspectRatio);
    label.setMaximumWidth(WIDTH);
    label.setMaximumHeight(HEIGHT - 60);
    label.setPixmap(pmap);
}
