#ifndef THEORYPAGE_H
#define THEORYPAGE_H

#include <QWidget>
#include <QtGui>
#include <vector>
#include <sstream>
#include <iostream>
#include "helper.h"

using namespace std;

class TheoryPage : public QWidget
{
    Q_OBJECT

private:
    int nbImages;
    QStackedWidget imagesStackedWidget;
    QLabel image1Label;
    QLabel image2Label;
    QLabel image3Label;
    QLabel image4Label;
    QLabel image5Label;
    QLabel image6Label;
    QLayout *layout;
    QPushButton nextButton;
    QPushButton prevButton;
    QPushButton backButton;

public:
    explicit TheoryPage(QWidget *parent = 0);
    ~TheoryPage();
    void createImage(QLabel &label, string imagePath);
signals:
    void backButtonPressed();
public slots:
    void displayPrevImage();
    void displayNextImage();
};

#endif // THEORYPAGE_H
