!
     subroutine xmatel_routine(nocc,nexl,inumocl,inumvil,nexr, &
          inumocr,inumvir,res_string,str_pointer)
       implicit none
       integer :: nocc,nexl,nexr,i,str_pointer
       integer :: inumocl(*),inumocr(*),inumvil(*),inumvir(*)
       character*1024 :: res_string
       integer, parameter :: nexmx_double=100

!
! we allocate statically all the arrays, of dimension 100 integers
!
       integer ::  ileft(nexmx_double),iright(nexmx_double), &
            ispinl(nexmx_double), ispinr(nexmx_double), &
            itypel(nexmx_double), ityper(nexmx_double), &
            ileft2(nexmx_double), iright2(nexmx_double),iholes(nexmx_double)  

       do i=1,nexmx_double
        ileft  (i)  =0
        iright (i)  =0
        ispinl (i)  =0
        ispinr (i)  =0
        itypel (i)  =0
        ityper (i)  =0
        ileft2 (i)  =0
        iright2(i)  =0
        iholes (i)  =0
       end do
       
       do i=1,nexl
        ileft(i)=inumocl(i)
        ileft(nexl+i)=inumvil(i)
       end do

       do i=1,nexr
        iright(i)=inumocr(i)
        iright(nexr+i)=inumvir(i)
       end do

       call xmatel(nocc,nexl,nexr,res_string,str_pointer,ileft,iright, &
            ispinl,ispinr,itypel,ityper,ileft2,iright2,iholes,nexmx_double) 

!      write(6,*)'|',res_string(1:str_pointer),'|'

     end subroutine xmatel_routine

     logical*1 function lsame(ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2)
       implicit none
       integer :: ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2
       lsame=.true.
       if (ii1.ne.ii2) lsame=.false.
       if (jj1.ne.jj2) lsame=.false.
       if (kk1.ne.kk2) lsame=.false.
       if (ll1.ne.ll2) lsame=.false.
       
     end function lsame
 
      subroutine xmatel(nocc,nexl,nexr,res_string,str_pointer,ileft,iright, &
           ispinl,ispinr, itypel,ityper,ileft2,iright2,iholes,nexmx_double) 
        implicit none
        character*1024 :: res_string
        integer :: nexmx_double,str_pointer,ii10,nocc
        integer ::  ileft(nexmx_double),iright(nexmx_double), &
             ispinl(nexmx_double), ispinr(nexmx_double), &
             itypel(nexmx_double), ityper(nexmx_double), &
             ileft2(nexmx_double), iright2(nexmx_double),iholes(nexmx_double)  

        integer :: nexl,nexr,i,j,norbi,isign,jsign,j1,ih,ihole
        integer :: ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2,iequal,ipart
        integer :: i1,i2,j2,ndiff,lspin,nholes,lsub,nequal,idum
        integer :: jj,lfound,irp1,irp2,irpa,irpb,nleft,nright,indx
        integer :: ilhb,ilpa,ilpb,irha,irhb,ilha
        logical*1 :: lsame
       character*1 :: csign(-1:1)
       character*1 :: cs1(2)
       character*2 :: cs2
       character*4 :: cs4
       character*14 :: cs14
       character*14 :: tstring
       str_pointer=1
       csign(-1)='-'
       csign( 0)=' '
       csign( 1)='+'
       cs2='F('
       cs4='E_HF'
       cs1(1)=','
       cs1(2)=')'

        do i=1,2*max(nexl,nexr)
         ileft2(i)=0
         iright2(i)=0
        end do

        do i=1,1024
         res_string(i:i)=' '
        end do
!
! how many holes in the lhs ?
        ilha=0
        ilhb=0
        ilpa=0
        ilpb=0
        do i=1,2*nexl
         if (ileft(i).lt.0) then
          if (abs(ileft(i)).le.nocc) then
           ilhb=ilhb+1
           itypel(i)=1
           ispinl(i)=1
          else 
           ilpb=ilpb+1
           itypel(i)=2
           ispinl(i)=1
          end if
         else if (ileft(i).gt.0) then
          if (ileft(i).le.nocc) then
           ilha=ilha+1 
           itypel(i)=1
           ispinl(i)=2
          else
           ilpa=ilpa+1 
           itypel(i)=2
           ispinl(i)=2
          end if
         end if
        end do
        
        irha=0
        irhb=0
        irpa=0
        irpb=0
        do i=1,2*nexr
         if (iright(i).lt.0) then
          if (abs(iright(i)).le.nocc) then
           irhb=irhb+1
           ityper(i)=1
           ispinr(i)=1
          else
           irpb=irpb+1
         ityper(i)=2
         ispinr(i)=1
        end if 
       else if (iright(i).gt.0) then
        if (iright(i).le.nocc) then
         irha=irha+1 
         ityper(i)=1
         ispinr(i)=2
        else
         irpa=irpa+1 
         ityper(i)=2
         ispinr(i)=2
        end if 
       end if 
      end do 
      nleft=ilha+ilhb+ilpa+ilpb
      nright=irha+irhb+irpa+irpb
      
      if (ilha.ne.ilpa) stop ' error in holes/particles alpha lhs'
      if (ilhb.ne.ilpb) stop ' error in holes/particles beta  lhs'
      if (irha.ne.irpa) stop ' error in holes/particles alpha rhs'
      if (irhb.ne.irpb) stop ' error in holes/particles beta  rhs'

! transform the strings to occupations
      indx=0
      do i=1,2*nexl
       if (ileft(i).ne.0.and.abs(ileft(i)).le.nocc) then
        indx=indx+1
        ileft2(indx)=ileft(i)
       end if
      end do
      if (indx.ne.nexl) stop ' left determinant incorrectly specified '

      do i=1,2*nexr
       if (iright(i).ne.0.and.abs(iright(i)).le.nocc) then
        indx=indx+1
        ileft2(indx)=iright(i)
       end if
      end do
      if (indx.ne.nexl+nexr) &
          stop ' right determinant incorrectly specified '

! eliminate same holes
!
      do i=1,nexl+nexr
       do j=i+1,nexl+nexr
        if (ileft2(i).eq.ileft2(j).and.ileft2(i).ne.0) then
         ileft2(j)=0 
        end if
       end do
      end do

      isign=1
!
! we may have nexl+nexr different holes
! 1 2 3 4
!
! they may be reduced to 3 or 2, and during this action the rhs holes
! may have changed their order
!
      norbi=nexl+nexr
      do i=1,nexl+nexr
       if (ileft2(i).eq.0) then
        lfound=0
        do j=i+1,nexl+nexr
         if (lfound.eq.0) then
          if (ileft2(j).ne.0) then
           ileft2(i)=ileft2(j)
           ileft2(j)=0
           lfound=1
          end if
         end if
        end do
       end if
      end do

      norbi=0
      do i=1,nexl+nexr
       if (ileft2(i).ne.0) norbi=norbi+1
      end do

! check order of the rhs holes
      if (irha.ge.2.or.irhb.ge.2) then
       do i=1,norbi
        if (ileft2(i).eq.iright(1)) irp1=i
        if (ileft2(i).eq.iright(2)) irp2=i
       end do
       if (irp1.gt.irp2) isign=-isign
      end if

!!$      write(6,9902) norbi,(ileft2(j),j=1,norbi)
 9902 format('   norbi = ',i4,' string ',20i4)
! save the string of the holes
      do i=1,norbi
       iholes(i)=ileft2(i)
      end do
      nholes=norbi

      do i=1,norbi
       iright2(i)=ileft2(i)
      end do

! now we have to place the particles

      do i=1,norbi
! if this hole appears in the left string, we look for an adequate
! particle 
       lfound=0
       do j=1,2*nexl
        if (ileft2(i).eq.ileft(j)) then
         lfound=1
         lspin=ispinl(j)
        end if
       end do
! and replace the hole
       if (lfound.eq.1) then
        lsub=0
        do j=1,2*nexl
         if (lsub.eq.0) then
! look for a particle with the same spin
          if ((lspin.eq.ispinl(j)).and.(itypel(j).eq.2)) then
           ileft2(i)=ileft(j)
           itypel(j)=0
           lsub=1
          end if
         end if
        end do
       end if
      end do
      
      do i=1,norbi
! if this hole appears in the right string, we look for an adequate
! particle 
       lfound=0
       do j=1,2*nexr
        if (iright2(i).eq.iright(j)) then
         lfound=1
         lspin=ispinr(j)
        end if
       end do
! and replace the hole
       if (lfound.eq.1) then
        lsub=0
        do j=1,2*nexr
         if (lsub.eq.0) then
! look for a particle with the same spin
          if ((lspin.eq.ispinr(j)).and.(ityper(j).eq.2)) then
           iright2(i)=iright(j)
           ityper(j)=0
           lsub=1
          end if
         end if
        end do
       end if
      end do
!
! now we have to determine how many of the indices are equal
!
      nequal=0
      do i=1,norbi
       lfound=0
       do j=1,norbi
        if (ileft2(i).eq.iright2(j).and.lfound.eq.0) then
         nequal=nequal+1
         lfound=1
         if (i.ne.j) then
! exchange i and j in the right string
          isign=-isign
          idum=iright2(j)
          iright2(j)=iright2(i)
          iright2(i)=idum          
         end if
        end if
       end do
      end do
!
! get the different particles to the left-hand side
      do i=1,norbi
       lfound=0
       do j=i,norbi
! are these already different ?
        if (ileft2(j).ne.iright2(j).and.lfound.eq.0) then
         idum=ileft2(i)
         ileft2(i)=ileft2(j)
         ileft2(j)=idum
         idum=iright2(i)
         iright2(i)=iright2(j)
         iright2(j)=idum
         lfound=1 
        end if
       end do
      end do
      
      ndiff=norbi-nequal

      if (ndiff.le.2) then
       
       do i=1,norbi
        if (ileft2(i).lt.0) then
         ispinl(i)=1
        else
         ispinl(i)=2
        end if
        if (iright2(i).lt.0) then
         ispinr(i)=1
        else
         ispinr(i)=2
        end if
       end do
!
       if (ndiff.eq.0) then
        tstring(1:1)=csign(isign)
        call addstr(str_pointer,1,tstring,res_string)
        tstring(1:4)=cs4
        call addstr(str_pointer,4,tstring,res_string)

!       write(6,*) ' norbi = ',norbi
        do i=1,norbi
         i1=abs(iholes(i))
         j1=abs(ileft2(i))

         tstring(1:1)=csign(-isign)
         call addstr(str_pointer,1,tstring,res_string)
         tstring(1:2)=cs2
         call addstr(str_pointer,2,tstring,res_string)
         call addnum(str_pointer,i1,res_string)
         tstring(1:1)=cs1(1)
         call addstr(str_pointer,1,tstring,res_string)
         call addnum(str_pointer,i1,res_string)
         tstring(1:1)=cs1(2)
         call addstr(str_pointer,1,tstring,res_string)
         
         tstring(1:1)=csign(-isign)
         call addstr(str_pointer,1,tstring,res_string)
         tstring(1:2)=cs2
         call addstr(str_pointer,2,tstring,res_string)
         call addnum(str_pointer,j1,res_string)
         tstring(1:1)=cs1(1)
         call addstr(str_pointer,1,tstring,res_string)
         call addnum(str_pointer,j1,res_string)
         tstring(1:1)=cs1(2)
         call addstr(str_pointer,1,tstring,res_string)
        end do
!
! hole-hole, hole-particle and particle-particle interactions
! hole-hole and part-part enter with +
! hole-part enter with -
! same-spin combinations are j-k
! different-spin combinations are j only
!
        do i=1,norbi
         do j=1,norbi

! hole-part and part-hole

          i1=abs(iholes(i))
          j1=abs(ileft2(j))
          
          jsign=1
          if (i1.le.nocc.and.j1.gt.nocc) jsign=-1 
          if (i1.gt.nocc.and.j1.le.nocc) jsign=-1
          if (ispinl(i).eq.ispinl(j)) then
           call addbi2(str_pointer,res_string,csign(isign*jsign), &
                i1,i1,j1,j1,csign(-isign*jsign),i1,j1,i1,j1)
          else
           call addbi1(str_pointer,res_string,csign(isign*jsign), &
                i1,i1,j1,j1)
          end if 

         end do
        end do

        do i=1,norbi-1
         do j=i+1,norbi
! hole-hole and part-part
          i1=abs(iholes(i))
          j1=abs(iholes(j))
          
          jsign=1
          if (i1.le.nocc.and.j1.gt.nocc) jsign=-1 
          if (i1.gt.nocc.and.j1.le.nocc) jsign=-1
          if (ispinl(i).eq.ispinl(j)) then
           call addbi2(str_pointer,res_string,csign(isign*jsign), &
                i1,i1,j1,j1,csign(-isign*jsign),i1,j1,i1,j1)
          else
           call addbi1(str_pointer,res_string,csign(isign*jsign), &
                i1,i1,j1,j1)
          end if
          
          
          i1=abs(ileft2(i))
          j1=abs(ileft2(j))
          
          jsign=1
          if (i1.le.nocc.and.j1.gt.nocc) jsign=-1 
          if (i1.gt.nocc.and.j1.le.nocc) jsign=-1
          if (ispinl(i).eq.ispinl(j)) then
           call addbi2(str_pointer,res_string,csign(isign*jsign), &
                i1,i1,j1,j1,csign(-isign*jsign),i1,j1,i1,j1)
          else
           call addbi1(str_pointer,res_string,csign(isign*jsign), &
                i1,i1,j1,j1)
          end if 

         end do
        end do
9922    format(' diagonal element : ',a1,' (',2i4,'|',2i4,' ) ', &
             a1,' (',2i4,'|',2i4,' ) ')
9923    format(' diagonal element : ',a1,' (',2i4,'|',2i4,' )')
       else if (ndiff.eq.1) then
        i=min(abs(ileft2(1)),abs(iright2(1)))
        j=max(abs(ileft2(1)),abs(iright2(1)))
        tstring(1:1)=csign(isign)
        call addstr(str_pointer,1,tstring,res_string)
        tstring(1:2)=cs2
        call addstr(str_pointer,2,tstring,res_string)
        call addnum(str_pointer,i,res_string)
        tstring(1:1)=cs1(1)
        call addstr(str_pointer,1,tstring,res_string)
        call addnum(str_pointer,j,res_string)
        tstring(1:1)=cs1(2)
        call addstr(str_pointer,1,tstring,res_string)
! subtract all hole interactions
        do ih=1,nholes
         ihole=iholes(ih)
         if (sign(1,ihole).eq.sign(1,ileft2(1))) then
          ihole=abs(ihole)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ihole
          ll1=ihole
          ii2=abs(ileft2(1))
          jj2=ihole
          kk2=abs(iright2(1))
          ll2=ihole
          call ocan(ii1,jj1,kk1,ll1)
          call ocan(ii2,jj2,kk2,ll2)
          if (.not.lsame(ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2)) then
           call addbi2(str_pointer,res_string,csign(-isign),ii1,jj1,kk1, &
                ll1,csign(isign),ii2,jj2,kk2,ll2)
          end if
         else
          ihole=abs(ihole)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ihole
          ll1=ihole
          call ocan(ii1,jj1,kk1,ll1)
           call addbi1(str_pointer,res_string,csign(-isign),ii1,jj1,kk1,ll1)
         end if 
        end do  
! add all particle interactions
        do iequal=1,nequal
         ipart=ileft2(1+iequal)
         if (sign(1,ipart).eq.sign(1,ileft2(1))) then
          ipart=abs(ipart)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ipart
          ll1=ipart
          ii2=abs(ileft2(1))
          jj2=ipart
          kk2=abs(iright2(1))
          ll2=ipart
          call ocan(ii1,jj1,kk1,ll1)
          call ocan(ii2,jj2,kk2,ll2)
          if (.not.lsame(ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2)) then
           call addbi2(str_pointer,res_string,csign(isign),ii1,jj1, &
               kk1,ll1,csign(-isign),ii2,jj2,kk2,ll2)
          end if
         else
          ipart=abs(ipart)
          ii1=abs(ileft2(1))
          jj1=abs(iright2(1))
          kk1=ipart
          ll1=ipart
          call ocan(ii1,jj1,kk1,ll1)
           call addbi1(str_pointer,res_string,csign(isign),ii1,jj1,kk1,ll1)
         end if
        end do
! we have the interaction with the holes 
       else if (ndiff.eq.2) then
        i1=ileft2(1)
        i2=ileft2(2)
        j1=iright2(1)
        j2=iright2(2)
        do i=1,2
         ileft2(i)=abs(ileft2(i))
         iright2(i)=abs(iright2(i))
        end do
! same spins
        if (ispinl(1).eq.ispinl(2)) then
         
         ii1=ileft2(1)
         jj1=iright2(1)
         kk1=ileft2(2)
         ll1=iright2(2)
         
         call ocan(ii1,jj1,kk1,ll1)
         
         ii2=ileft2(1)
         jj2=iright2(2)
         kk2=ileft2(2)
         ll2=iright2(1)
         call ocan(ii2,jj2,kk2,ll2)
         if (.not.lsame(ii1,jj1,kk1,ll1,ii2,jj2,kk2,ll2)) then
          call addbi2(str_pointer,res_string,csign(isign), &
               ii1,jj1,kk1,ll1,csign(-isign),ii2,jj2,kk2,ll2)
         end if
        else
         ii1=ileft2(1)
         jj1=iright2(1)
         kk1=ileft2(2)
         ll1=iright2(2)
         call ocan(ii1,jj1,kk1,ll1)
           call addbi1(str_pointer,res_string,csign(isign), &
                ii1,jj1,kk1,ll1)
        end if
       end if
      else
       cs14='no interaction'
       call addstr(str_pointer,14,cs14,res_string)
      end if

      str_pointer=str_pointer-1

    end subroutine xmatel
    
    subroutine ocan(i,j,k,l)
      implicit none
      integer :: i,j,k,l
      integer :: i1,j1,k1,l1,idum
      
      i1=i
      j1=j
      k1=k
      l1=l
      
      if (i1.gt.j1) then
       idum=i1
       i1=j1
       j1=idum
      end if
      if (k1.gt.l1) then
       idum=k1
       k1=l1
       l1=idum
      end if
      
      if (i1.gt.k1) then
       idum=i1
       i1=k1
       k1=idum
       idum=j1
       j1=l1
       l1=idum
      else if (i1.eq.k1) then
       if (j1.gt.l1) then
        idum=j1
        j1=l1
        l1=idum
       end if
      end if
      
      i=i1
      j=j1
      k=k1
      l=l1
      
    end subroutine ocan

    subroutine addstr(str_pointer,strleng,str,res_string)
      implicit none
      character*1024 :: res_string
      integer :: strleng
      character*14 :: str
      integer :: str_pointer
      res_string(str_pointer:str_pointer+strleng-1)=str(1:strleng)
      str_pointer=str_pointer+strleng
    end subroutine addstr

    subroutine addbi2(str_pointer,res_string,c1,i1,j1, &
               k1,l1,c2,i2,j2,k2,l2)
      implicit none
      integer :: i1,j1,k1,l1,i2,j2,k2,l2
      character*1 :: c1,c2
      character*1024 :: res_string
      integer :: str_pointer
      character*1 :: cs1(4)
      character*14 :: tstring
      data cs1 /'(',',','|',')'/

      tstring(1:1)=c1
      call addstr(str_pointer,1,tstring,res_string)
      tstring(1:1)=cs1(1)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,i1,res_string)
      tstring(1:1)=cs1(2)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,j1,res_string)
      tstring(1:1)=cs1(3)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,k1,res_string)
      tstring(1:1)=cs1(2)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,l1,res_string)
      tstring(1:1)=cs1(4)
      call addstr(str_pointer,1,tstring,res_string)

      tstring(1:1)=c2
      call addstr(str_pointer,1,tstring,res_string)
      tstring(1:1)=cs1(1)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,i2,res_string)
      tstring(1:1)=cs1(2)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,j2,res_string)
      tstring(1:1)=cs1(3)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,k2,res_string)
      tstring(1:1)=cs1(2)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,l2,res_string)
      tstring(1:1)=cs1(4)
      call addstr(str_pointer,1,tstring,res_string)

    end subroutine addbi2

    subroutine addbi1(str_pointer,res_string,c1,i1,j1, &
               k1,l1)
      implicit none
      integer :: i1,j1,k1,l1
      character*1 :: c1
      character*1024 :: res_string
      integer :: str_pointer
      character*1 :: cs1(4)
      character*14 :: tstring
      data cs1 /'(',',','|',')'/

      tstring(1:1)=c1
      call addstr(str_pointer,1,tstring,res_string)
      tstring(1:1)=cs1(1)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,i1,res_string)
      tstring(1:1)=cs1(2)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,j1,res_string)
      tstring(1:1)=cs1(3)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,k1,res_string)
      tstring(1:1)=cs1(2)
      call addstr(str_pointer,1,tstring,res_string)
      call addnum(str_pointer,l1,res_string)
      tstring(1:1)=cs1(4)
      call addstr(str_pointer,1,tstring,res_string)

    end subroutine addbi1

    subroutine addnum(str_pointer,i,res_string)
      implicit none
      integer :: i,ii10,ii1,str_pointer
      character*1024 :: res_string 
      character*1 :: cstr(0:9)
      character*14 :: tstring
      data cstr /'0','1','2','3','4','5','6','7','8','9'/
      if (i.lt.10) then
       tstring(1:1)=cstr(i)
       call addstr(str_pointer,1,tstring,res_string)
      else
       ii10=i/10
       ii1=i-10*ii10
       tstring(1:2)=cstr(ii10)//cstr(ii1)
       call addstr(str_pointer,2,tstring,res_string)
      end if
    end subroutine addnum
